<?php
/*
*
* JetBackup @ package
* Created By Idan Ben-Ezra
*
* Copyrights @ JetApps LLC
* https://www.jetapps.com
*
**/

pm_Context::init('jetbackup5');
$client = pm_Session::getClient();

$login_as = '';
if(isset($_REQUEST['dom_id']) && $_REQUEST['dom_id']) {
	$domain = pm_Domain::getByDomainId($_REQUEST['dom_id']);
	if(!$domain->hasHosting()) throw new pm_Exception('Domain without hosting isn\'t supported');
	if(!$client->hasPermission('manage_jetbackup', $domain)) throw new pm_Exception('Permission denied');
	$username = $domain->getSysUserLogin();
} elseif($client->isAdmin()) {
	$username = 'root';
} elseif($client->hasPermission('manage_jetbackup')) {
	$username = 'root';
	$login_as = $client->getLogin();
} else {
	throw new pm_Exception('Permission denied');
}

$data = [];
$input = file_get_contents('php://input');
if($input) $data = array_merge($data, json_decode($input, true));
if(isset($_REQUEST)) $data = array_merge($data, $_REQUEST);
$data['panel_locale'] = $client->getProperty('locale');
$data['login_as'] = $login_as;

$output = pm_ApiCli::callSbin("jetbackupadmin", [$username, json_encode($data)], pm_ApiCli::RESULT_EXCEPTION, [
	'SERVER_SOFTWARE' => '',
	'GATEWAY_INTERFACE' => '',
	'REQUEST_METHOD' => '',
]);
if($output['code']) throw new pm_Exception("Failed loading JetBackup. Error: {$output['stderr']}");

list($headers, $body) = explode("\r\n\r\n", $output['stdout'], 2);
$headers = explode("\r\n", $headers);

if(isset($data['download']) && $data['download'] && substr($body, 0, 9) == "download|") {
	$filename = substr($body, 9);
	
	if(!file_exists($filename)) die("Can't find download file. We probably don't have permissions to access this file ($filename). Please make sure that the user 'psaadm' has permissions to read in the downloads directory");
	$fd = fopen($filename, "rb");
	if(!$fd) die('Can\'t open file');
	@ob_end_clean();

	foreach($headers as $header) header($header);

	flush();
	while(!feof($fd)) {
		echo fread($fd, 1024);
		flush();
	}
	fclose($fd);
	exit;
}

foreach($headers as $header) header($header);
echo $body;

?>
